Vueナビゲーション
このガイドでは、IonicとVueで構築されたアプリでルーティングがどのように機能するかについて説明します。
IonRouterOutlet
コンポーネントは、内部で一般的な
Vue Router ライブラリを使用します。IonicとVue Routerを使えば、リッチなページ遷移を持つマルチページアプリを作ることができます。
Vue Routerを使ったルーティングについて知っていることはすべてIonic Vueに引き継がれます。Ionic Vueアプリの基本とルーティングの仕組みを見てみましょう。
簡単なメモ
このガイドを読むと、これらの概念のほとんどが、Ionic Frameworkを使用しないVueルータに見られる概念と非常によく似ていることがわかります。あなたの意見は正しいでしょう!Ionic VueはVue Routerの長所を活用して、Ionic Frameworkを使ったアプリ構築への移行を可能な限りシームレスにしています。そのため、独自のルーティングソリューションを構築するよりも、可能な限りVueルータの機能に依存することをお勧めします。
簡単なRoute
次に示すのは、 "/home" URLへの単一のルートを定義するルーティング設定の例です。 "/home" にアクセスすると、ルートによって
HomePage
コンポーネントがレンダリングされます。
router/index.ts
import { createRouter, createWebHistory } from '@ionic/vue-router';
import { RouteRecordRaw } from 'vue-router';
import HomePage from '@/views/Home.vue';
const routes: Array<RouteRecordRaw> = [
{
path: '/',
name: 'Home',
component: HomePage
},
]
const router = createRouter({
history: createWebHistory(process.env.BASE_URL),
routes
});
export default router;
アプリケーションが最初にロードされると、 HomePage
コンポーネントがここで設定したとおりに表示されます。
リダイレクトの設定
最初ロードされたパスに別のパスを設定したい場合はどうすればよいでしょうか。これには、ルータリダイレクトを使用できます。リダイレクトは通常のルートオブジェクトと同じように機能しますが、いくつかの異なるキーが含まれています。
const routes: Array<RouteRecordRaw> = [
{
path: '/',
redirect: '/home'
},
{
path: '/home',
name: 'Home',
component: HomePage
},
]
このリダイレクトでは、最初にインデックスのパスが参照されます。そして、 home
routeにリダイレクトしてロードを行います。
異なるRoutesへのナビゲーション
これは素晴らしいことですが、実際にルートにナビゲートするにはどうすればよいのでしょうか。これには、
router-link
プロパティを使用できます。新しいルーティング設定を作成します:
const routes: Array<RouteRecordRaw> = [
{
path: '/',
redirect: '/home'
},
{
path: '/home',
name: 'Home',
component: HomePage
},
{
path: '/detail',
name: 'Detail',
component: DetailPage
}
]
home
routeで開始し、detail
routeに移動するボタンを追加するとします。detail
routeに移動するには、次のHTMLを使用します:
<ion-button router-link="/detail">Go to detail</ion-button>
また、ルーターAPIを使用して、プログラムでアプリケーション内を移動することもできます:
<template>
<ion-page>
<ion-content>
<ion-button @click="() => router.push('/detail')">Go to detail</ion-button>
</ion-content>
</ion-page>
</template>
<script lang="ts">
import { IonButton, IonContent, IonPage } from '@ionic/vue';
import { defineComponent } from 'vue';
import { useRouter } from 'vue-router';
export default defineComponent({
name: 'HomePage',
components: {
IonButton,
IonContent,
IonPage
},
setup() {
const router = useRouter();
return { router };
}
})
</script>
どちらのオプションも同じナビゲーション機構を提供し、異なるユースケースに対応します。
遅延読み込みRoute
現在のrouteの設定方法では、アプリをロードするときに同じ初期チャンクに含まれるようになっているが、これは必ずしも理想的ではありません。代わりに、必要に応じてコンポーネントがロードされるようにrouteを設定できます。
const routes: Array<RouteRecordRaw> = [
{
path: '/',
redirect: '/home'
},
{
path: '/home',
name: 'Home',
component: HomePage
},
{
path: '/detail',
name: 'Detail',
component: () => import('@/views/DetailPage.vue')
}
]
ここでは、以前と同じ設定になっていますが、今回は DetailPage
がimport callに置き換えられました。これにより、アプリケーションのロード時に要求されたチャンクに
DetailPage
コンポーネントが含まれなくなります。
共有URLとネストされたルート
ルーティングを設定する際の一般的な混乱点は、共有URLまたはネストされたrouteのどちらかを決定することです。ガイドのこの部分では、両方について説明し、どちらを使用するかを決定するのに役立ちます。
共有URL
共有URLは、ルートが共通のURLの一部を持つルート設定です。共有URL設定の例を次に示します:
const routes: Array<RouteRecordRaw> = [
{
path: '/dashboard',
component: DashboardMainPage,
},
{
path: '/dashboard/stats',
component: DashboardStatsPage
}
];
上記のルートは、URLの dashboard
部分を再利用するため、 "shared" と見なされます。
ネストされたRoute
Nested Routesは、ルートが他のルートの子としてリストされるルート設定です。ネストされたルート設定の例を次に示します:
const routes: Array<RouteRecordRaw> = [
{
path: '/dashboard/:id',
component: DashboardRouterOutlet,
children: [
{
path: '',
component: DashboardMainPage
},
{
path: 'stats',
component: DashboardStatsPage
},
]
}
];
上記のルートは、親ルートの children
配列にあるため、ネストされています。親ルートが
DashboardRouterOutlet
コンポーネントをレンダリングしていることに注目してください。ルートをネストする場合は、
ion-router-outlet
の別のインスタンスをレンダリングする必要があります。
どちらを選ぶべきか
共有URLは、URLの2つのページ間の関係を維持しながら、ページAからページBに遷移する場合に便利です。前述の例では、
/dashboard
ページのボタンで
/dashboard/stats
ページに移行できます。2つのページ間の関係は、a) ページの遷移とb) URLによって維持されます。
ネストされたルートは、コンセントAのコンテンツをレンダリングする必要がある場合、およびネストされたコンセントBの内部のサブコンテンツをレンダリングする必要がある場合に便利です。最も一般的な使用例は、タブです。Ionicスターターアプリのタブをロードすると、最初の
ion-router-outlet
で ion-tab-bar
および
ion-tabs
コンポーネントがレンダリングされます。ion-tabs
コンポーネントは、各タブの内容をレンダリングする別の 「イオンルータ出力」 をレンダリングします。
モバイルアプリケーションでネストされたルートが意味をなすユースケースはほとんどありません。疑わしい場合は、共有URLルート設定を使用します。ネストされたルーティングをタブ以外のコンテキストで使用すると、アプリのナビゲーションが混乱する可能性があるため、使用しないように強く注意しています。
例外は、タブの子を操作する場合です。詳しくは Child Routes within Tabs をご覧ください。
タブの操作
タブを操作する場合、Ionic Vueはどのビューがどのタブに属しているかを知る方法を必要とします。ここでは IonTabs
コンポーネントが便利ですが、この場合のルーティング設定を見てみましょう:
const routes: Array<RouteRecordRaw> = [
{
path: '/',
redirect: '/tabs/tab1'
},
{
path: '/tabs/',
component: Tabs,
children: [
{
path: '',
redirect: 'tab1'
},
{
path: 'tab1',
component: () => import('@/views/Tab1.vue')
},
{
path: 'tab2',
component: () => import('@/views/Tab2.vue')
},
{
path: 'tab3',
component: () => import('@/views/Tab3.vue')
}
]
}
]
ここで、 tabs
パスは
Tabs
コンポーネントをロードします。各タブは、
children
配列内のルートオブジェクトとして提供されます。この例では、パスを
tabs
としていますがこれはカスタマイズできます。
まず、 Tabs
コンポーネントをみていきましょう:
<template>
<ion-page>
<ion-content>
<ion-tabs>
<ion-tab-bar slot="bottom">
<ion-tab-button tab="tab1" href="/tabs/tab1">
<ion-icon :icon="triangle" />
<ion-label>Tab 1</ion-label>
</ion-tab-button>
<ion-tab-button tab="tab2" href="/tabs/tab2">
<ion-icon :icon="ellipse" />
<ion-label>Tab 2</ion-label>
</ion-tab-button>
<ion-tab-button tab="tab3" href="/tabs/tab3">
<ion-icon :icon="square" />
<ion-label>Tab 3</ion-label>
</ion-tab-button>
</ion-tab-bar>
</ion-tabs>
</ion-content>
</ion-page>
</template>
<script lang="ts">
import { IonTabBar, IonTabButton, IonTabs, IonContent, IonLabel, IonIcon, IonPage } from '@ionic/vue';
import { ellipse, square, triangle } from 'ionicons/icons';
export default {
name: 'Tabs',
components: { IonContent, IonLabel, IonTabs, IonTabBar, IonTabButton, IonIcon, IonPage },
setup() {
return {
ellipse,
square,
triangle,
}
}
}
</script>
以前にIonic Frameworkを使ったことがある人なら、このことをよく知っているはずです。ion-tabs
コンポーネントを作成し、
ion-tab-bar
を提供します。ion-tab-bar
は ion-tab-button
コンポーネントを提供し、それぞれにルータの設定の対応するタブに関連付けられた
tab
プロパティがあります。
タブ内の子ルート
先程、ほとんどの経路は共有URL設定で書かれるべきだと論じました。この規則の例外は、子ルートをタブに追加する場合です。これは、タブルートと同じレベルに子ルートを記述した場合、Ionic Vueは子ページとルートタブページを区別できないためです。
そのため、子ルートをタブに追加する場合は、常にネストされたルートとして記述する必要があります。Ionic Vueは内部ロジックを処理するため、
IonRouterOutlet
を追加する必要はありません:
const routes: Array<RouteRecordRaw> = [
{
path: '/',
redirect: '/tabs/tab1'
},
{
path: '/tabs/',
component: Tabs,
children: [
{
path: '',
redirect: 'tab1'
},
{
path: 'tab1',
component: () => import('@/views/Tab1.vue'),
children: [
{
path: 'child',
component: () => import('@/views/Tab1Child.vue')
}
]
},
{
path: 'tab2',
component: () => import('@/views/Tab2.vue')
},
{
path: 'tab3',
component: () => import('@/views/Tab3.vue')
}
]
}
]
上記の例では、/tabs/tab 1/child
ルートを
/tabs/tab1
ルートの子として定義しています。
IonRouterOutlet
IonRouterOutlet
コンポーネントは、ビューをレンダリングするためのコンテナを提供します。これは他のVueアプリケーションに見られる
RouterView
コンポーネントに似ていますが、
IonRouterOutlet
は同じアウトレット内のDOMで複数のページをレンダリングできるという点が異なります。コンポーネントが
IonRouterOutlet
でレンダリングされる場合、これはIonic Framework "Page"と見なされます。ルーター・アウトレット・コンテナーは、ページ間の遷移アニメーションを制御するだけでなく、ページがいつ作成および破棄されるかを制御します。これにより、ビューを切り替えるときにビュー間の状態を維持することができます。
テンプレートで設定する際に、 IonRouterOutlet
の内部には何も指定しないでください。IonRouterOutlet
は子コンポーネントにネストすることができますが、通常はアプリケーション内のナビゲーションが混乱するため注意が必要です。詳細については、Shared URLs versus Nested Routes を参照してください。
IonRouter インスタンスへのアクセス
Vueアプリケーション内から IonRouter
インスタンスにアクセスする必要があるユースケースがいくつかあるかもしれません。例えば、Androidでユーザーがハードウェアの 「戻る」 ボタンを押したときに、アプリケーションのルート・ページにいるかどうかを知ることができます。このようなユースケースでは、コンポーネントに
IonRouter
依存関係を注入できます。
import { useIonRouter } from '@ionic/vue';
...
export default {
setup() {
const ionRouter = useIonRouter();
if (ionRouter.canGoBack()) {
// Perform some action here
}
}
}
URLパラメーター
元のルーティング例を拡張して、URLパラメータの使用方法を示します:
const routes: Array<RouteRecordRaw> = [
{
path: '/',
redirect: '/home'
},
{
path: '/home',
name: 'Home',
component: HomePage
},
{
path: '/detail/:id',
name: 'Detail',
component: DetailPage
}
]
ここで、 detail
パス文字列の最後に
:id
を追加したことに注意してください。URLパラメータは、ルートパスの動的な部分です。ユーザーが
/details/1
などのURLに移動すると、 "1" が "id" という名前のパラメータに保存され、ルートのレンダリング時にコンポーネントでアクセスできるようになります。
コンポーネントでの使用方法を見てみましょう。
<template>
<ion-page>
<ion-header>
<ion-toolbar>
<ion-title>Details</ion-title>
</ion-toolbar>
</ion-header>
<ion-content>
Detail ID: {{ id }}
</ion-content>
</ion-page>
</template>
<script lang="ts">
import { IonContent, IonHeader, IonPage, IonTitle, IonToolbar } from '@ionic/vue';
import { defineComponent } from 'vue';
import { useRoute } from 'vue-router';
export default defineComponent({
name: 'Detail',
components: {
IonContent,
IonHeader,
IonPage,
IonTitle,
IonToolbar
},
setup() {
const route = useRoute();
const { id } = route.params;
return { id };
}
})
</script>
route
変数には、現在のルートのインスタンスが含まれます。また、渡されたパラメータも含まれます。ここから
id
パラメータを取得して画面に表示できます。
ルーター履歴
Vueルータには設定可能な履歴モードが付属しています。さまざまなオプションと、それぞれを使用する理由について説明します。
createWebHistory
: このオプションはHTML 5ヒストリを作成します。History APIを利用して、ページをリロードせずにURLナビゲーションを実現している。これは、単一ページアプリケーションで最も一般的な履歴モードです。疑わしい場合は、createWebHistory
を使用します。createWebHashHistory
: このオプションは、ハッシュ (#
) をURLに追加します。これは、ホストがないWebアプリケーションや、サーバールートを完全に制御できない場合に便利です。検索エンジンはハッシュの断片を無視することがあるので、SEOがあなたのアプリケーションにとって重要であるなら、代わりにcreateWebHistory
を使うべきです。createMemoryHistory
: このオプションは、インメモリベースのヒストリを作成します。これは主にサーバ側レンダリング (SSR) を処理するために使用されます。
より多くの情報を得るために
Vueルータを使ったVueでのルーティングの詳細については、 http://router.vuejs.org/ のドキュメントをご覧ください。

Reactナビゲーション
このガイドでは、IonicとReactで構築されたアプリでのルーティングの仕組みについて説明します。
IonReactRouter
は一般的な
React Router ライブラリを内部で使用しています。Ionic と React Router を使うことで、ページ遷移がリッチなマルチページアプリをつくることができます。
React Routerを使用したルーティングについて知っていることはすべて、Ionic Reactで利用することができます。Ionic Reactアプリの基本と、ルーティングがどのように機能するかを見てみましょう。
Ionic Reactにおけるルーティング
これは App
コンポーネントのサンプルで、 "/dashboard" URLへの単一ルートを定義しています。"/dashboard"にアクセスすると、
DashboardPage
コンポーネントをレンダリングします。
App.tsx
const App: React.FC = () =>
(
<IonApp>
<IonReactRouter>
<IonRouterOutlet>
<Route path="/dashboard" component={DashboardPage} />
<Redirect exact from="/" to="/dashboard" />
</IonRouterOutlet>
</IonReactRouter>
</IonApp>
);
Route
の直後に、デフォルトの
Redirect
を定義します。これは、ユーザーがアプリのルートURL("/")にアクセスすると、"/dashboard" URLにリダイレクトします。
リダイレクトには exact
という prop もあります。つまり、このルートが一致するためには、URLが
from
prop(もしくは
Route
で exact
が使われている場合の
path
prop)と正確に一致する必要があります。すべてのルートは"/"で始まるため、これがないと、このリダイレクトはすべてのルートに対してレンダリングされます。
ユーザーが認証されているかどうかを確認するなど、条件に基づいてルートのrenderメソッドからプログラムでリダイレクトすることもできます:
<Route
exact
path="/dashboard"
render={props => {
return isAuthed ? <DashboardPage {...props} /> : <LoginPage />;
}}
/>
IonReactRouter
IonReactRouter
コンポーネントは、React Routerの従来の
BrowserRouter
コンポーネントをラップし、アプリケーションをルーティング用にセットアップします。したがって、
BrowserRouter
の代わりに
IonReactRouter
を使用します。任意のpropを
IonReactRouter
に渡すことができ、それらはベースとなる
BrowserRouter
に渡されます。
ルーターのネスト
DashboardPage 内で、アプリのこの特定のセクションに関連するルートをさらに定義します。
DashboardPage.tsx
const DashboardPage: React.FC = () => {
return (
<IonRouterOutlet>
<Route exact path="/dashboard" component={UsersListPage} />
<Route path="/dashboard/users/:id" component={UserDetailPage} />
</IonRouterOutlet>
);
};
ここでは、アプリの DashboardPage から更にコンポーネントが定義された2つのルートがあります。pathにはルートの全体を定義する必要があり、そのURLからこのページに到達した場合でも、 "/dashboard" を省略できないことに注意してください。 React Routerは絶対パスを必要とし、相対パスはサポートされていません。
ただし、 match
オブジェクトの
url
プロパティを使用して、コンポーネントをレンダリングするために match したURLを提供できます。これは、ネストされたルートを操作するときに役立ちます。
const DashboardPage: React.FC<RouteComponentProps> = ({match}) => {
return (
<IonRouterOutlet>
<Route exact path={match.url} component={UsersListPage} />
<Route path={`${match.url}/users/:id`} component={UserDetailPage} />
</IonRouterOutlet>
);
};
ここでは、 match.url
には "/dashboard" の値が含まれています。これは、
DashboardPage
のレンダリングに使用されるURLであるためです。
これらのルートは IonRouterOutlet
にグループ化されています。次に説明します。
IonRouterOutlet
IonRouterOutlet
コンポーネントは、Ionicの "ページ" をレンダリングするルートコンテナを提供します。 ページが
IonRouterOutlet
にある場合、コンテナはページ間の遷移アニメーションを制御し、ページが作成および破棄されるタイミングを制御します。これにより、ビューを切り替える際にビュー間の状態を維持できます。
上記の DashboardPage
には、ユーザーリストページと詳細ページが表示されます。 2つのページ間を移動するとき、
IonRouterOutlet
は適切なプラットフォームページの遷移を提供し、前のページの状態をそのまま保持するため、ユーザーがリストページに戻ると、前のページと同じ状態で表示されます。
IonRouterOutlet
には、
Route
と Redirect
のみを含める必要があります。 他のコンポーネントは、
Route
の結果、または
IonRouterOutlet
の外部でレンダリングする必要があります。
IonRouterOutlet
は別の
IonRouterOutlet
の子孫であってはいけません。
Navigation
Ionic Reactアプリでさまざまなビューにルーティングする場合、いくつかのオプションを使用できます。 ここで、
UsersListPageはIonItem
は
IonItem
の routerLink
prop を使用して、タップ/クリックされたときに移動するルートを指定します:
UsersListPage.tsx
const UsersListPage: React.FC = () => {
return (
<IonPage>
<IonHeader>
<IonToolbar>
<IonTitle>Users</IonTitle>
</IonToolbar>
</IonHeader>
<IonContent>
<IonList>
<IonItem routerLink="/dashboard/users/1">
<IonLabel>User 1</IonLabel>
</IonItem>
<IonItem routerLink="/dashboard/users/2">
<IonLabel>User 2</IonLabel>
</IonItem>
</IonList>
</IonContent>
</IonPage>
);
};
Other components that have the routerLink
prop are
IonButton
, IonCard
, IonRouterLink
,
IonFabButton
, and IonItemOption
.
Each of these components also have a routerDirection
prop to explicitly set the type of page transition to use ("back", "forward", or "none").
Outside of these components that have the routerLink
prop, you can also use React Routers
Link
component to navigate between views:
<Link to="/dashboard/users/1">User 1</Link>
ルーティングは可能な限り、上記の方法のいずれかを使用することをお勧めします。 これらのアプローチの利点は、両方ともアンカー( <a>
)タグをレンダリングすることです。これはアプリ全体のアクセシビリティに適しています。
ナビゲーションのためのプログラムオプションとして、React Routerがルート経由でレンダリングするコンポーネントに提供する
history
prop を使用することもできます。
<IonButton
onClick={e => {
e.preventDefault();
history.push('/dashboard/users/1');
}}>
Go to User 1
</IonButton>
Note:
history
は prop.
URLパラメーター
Dashboard Pageで定義された2番目のルートには、URLパラメーターが定義されています(パスの ":id" 部分)。 URLパラメーターは
path
の動的な部分であり、ユーザーが "/dashboard/users/1" などのURLに移動すると、"1" はルートがレンダリングするコンポーネント上で "id" という名前のパラメーターに保存されます。それがどのように行われるかを見てみましょう。
UserDetailPage.tsx
interface UserDetailPageProps extends RouteComponentProps<{
id: string;
}> {}
const UserDetailPage: React.FC<UserDetailPageProps> = ({match}) => {
return (
<IonPage>
<IonHeader>
<IonToolbar>
<IonTitle>User Detail</IonTitle>
</IonToolbar>
</IonHeader>
<IonContent>
User {match.params.id}
</IonContent>
</IonPage>
);
};
match
prop には、URLパラメーターなど、一致したルートに関する情報が含まれます。 ここで
id
パラメータを取得し、画面に表示します。
Note: TypeScriptインターフェイスを使用して props オブジェクトを厳密に入力する方法に注意してください。 このインターフェースにより、コンポーネント内部でタイプセーフティとコード補完が可能になります。
Live Example
If you would prefer to get hands on with the concepts and code described above, please checkout our live example of the topics above on StackBlitz.
IonRouterOutlet in a Tabs View
Tabビューで作業する場合、Ionic Reactには、どのビューがどのTabに属しているかを判断する方法が必要です。これは、
Route
に提供されるパスが正規表現であるという事実を利用することにより実現します。
この構文は少し不思議に見えますが、理解すればかなり簡単です。
例えば、2つのタブ (sessions と speakers) をもつビューのルートは次のように設定できます:
<IonRouterOutlet>
<Route path="/:tab(sessions)" component={SessionsPage} exact={true} />
<Route path="/:tab(sessions)/:id" component={SessionDetail} />
<Route path="/:tab(speakers)" component={SpeakerList} exact={true} />
</IonRouterOutlet>
ナビゲートされたURLが "/sessions" の場合、最初のルートと一致します。 "tab" というURLパラメーターに "sessions" の値を格納して、
match
オブジェクトに
SessionsPage
として追加します。
ユーザーがセッションの詳細ページ(たとえば "/sessions/1" )に移動すると、2番目のルートは "tabs" というURLパラメーターに "sessions" という値を追加します。
IonRouterOutlet
は、両方のページが同じ "sessions" タブにあることを認識すると、新しいビューへのアニメーションページ遷移を提供します。 ユーザーが新しいタブ(この場合は "speakers" )に移動すると、
IonRouterOutlet
はアニメーションを提供しないことを認識します。
IonRouterOutletの Switch
IonRouterOutlet
がどのルートをレンダリングするかを決定するジョブを引き継ぐため、IonRouterOutlet内で使用する場合、React Routerからの
Switch
を使用しても効果はありません。
IonRouterOutlet
の外部で使用する場合、
Switch
は引き続き期待どおりに機能します。
更に知りたい場合
React Routerを使用したReactでのルーティングの詳細については、次の https://reacttraining.com/react-router/web でドキュメントをご覧ください。
From the Community
Ionic 4 and React: Navigation - Paul Halliday

Angularナビゲーション
このガイドでは、IonicとAngularを使用して構築されたアプリでのルーティングのしくみについて説明します。
Angular Routerは、Angularアプリケーションで最も重要なライブラリの1つです。これがなければ、アプリはシングルビュー/シングルコンテキストアプリになるか、ブラウザのリロード時にナビゲーションのステートを維持できなくなります。Angular Routerを使用すると、リンク可能でリッチなアニメーションを持つリッチなアプリを作成できます(もちろん、Ionicと組み合わせると!)。Angular Routerの基本と、それをIonicアプリケーション用に設定する方法を見てみましょう。
シンプルなRoute
ほとんどのアプリでは、some sort of route を持つことがしばしば必要になります。最も基本的な設定はこのようになります:
import { RouterModule } from '@angular/router';
@NgModule({
imports: [
...
RouterModule.forRoot([
{ path: '', component: LoginComponent },
{ path: 'detail', component: DetailComponent },
])
],
})
URL path と Component の組み合わせを確認する最も簡単な方法は、ここをみるすることです。アプリがロードされると、ルーターはユーザーがロードしようとしているURLを読むことで動作を開始します。私たちのサンプルでは、Routeは
''
を参照します。これは本質的に私たちのインデックスルートとなります。そうすると、一致するエントリを探し出して、
LoginComponent
がロードされます。かなり簡単です。この処理は
path
が一致するまで、設定されているすべてのRouteのエントリを参照します。しかし、初期ロードと異なるパスをロードしたい場合はどうなりますか?
リダイレクトの処理
そういう場合には、ルーターリダイレクトを使用できます。リダイレクトは通常のルートオブジェクトと同じように書くことができますが、いくつかの異なるキーが含まれます。
[
{ path: '', redirectTo: 'login', pathMatch: 'full' },
{ path: 'login', component: LoginComponent },
{ path: 'detail', component: DetailComponent }
];
このリダイレクトでは、アプリのインデックス(''
)を探しはじめると、login
にリダイレクトします。最後の pathMatch
キーは、ルータにパスの検索方法を指示するために必要です。
full
を使用すると、たとえ最後まで
/route1/route2/route3
と一致するpathがなかったとしても、フルパスを比較する必要があることをルータに伝えることができます。つまり、次のようになります。
{ path: '/route1/route2/route3', redirectTo: 'login', pathMatch: 'full' },
{ path: 'login', component: LoginComponent },
このように書くと /route1/route2/route3
をロードすると、リダイレクトを行います。けれど仮に
/route1/route2/route4
であれば、すべてのpathが一致しないのでリダイレクトを行いません。
あるいは、こういう書き方もできます:
{ path: '/route1/route2', redirectTo: 'login', pathMatch: 'prefix' },
{ path: 'login', component: LoginComponent },
/route1/route2/route3
と
/route1/route2/route4
の両方を読み込んだとおき, どちらの場合もリダイレクトします。
pathMatch: 'prefix'
によって、一部でも一致したら該当するからです。
routesへのナビゲーション
routesについて説明してきましたが、それではどのようにしてそのルートにナビゲーションしたらいいのでしょうか。これには、
routerLink
directiveを利用します。先ほどの簡単なrouter設定でこれを確認してみましょう:
RouterModule.forRoot([
{ path: '', component: LoginComponent },
{ path: 'detail', component: DetailComponent }
]);
わたしたちは、次のHTMLを利用することで、LoginComponent
から
detail
routeに遷移することができます。
<ion-header>
<ion-toolbar>
<ion-title>Login</ion-title>
</ion-toolbar>
</ion-header>
<ion-content class="ion-padding">
<ion-button [routerLink]="['/detail']">Go to detail</ion-button>
</ion-content>
ここで重要なのはion-button
と
routerLink
directiveです。RouterLinkは典型的な
href
と同様の考えで動作しますが、URLを文字列として構築する代わりに配列として構築することができ、それによってより複雑なパスを書くこともできます。
Router APIを使用して、プログラムで遷移することもできます。
import { Component } from '@angular/core';
import { Router } from '@angular/router';
@Component({
...
})
export class LoginComponent {
constructor(private router: Router){}
navigate(){
this.router.navigate(['/detail'])
}
}
どちらのオプションも同様のナビゲーションメカニズムを提供し、異なるユースケースで利用することができます。
相対URLを使用したナビゲーションに関するメモ:現在、複数のナビゲーションスタックをサポートするために、相対URLはサポートされていません。
Lazy loading routes
現在のルート設定では、すべてのComponentが、ルートとなる
app.module
と同じ
chunk
に含まれているので理想的ではありません。代わりに、ルータにはコンポーネントを独自の
chunk
に分離できるように設定されています。
import { RouterModule } from '@angular/router';
@NgModule({
imports: [
...
RouterModule.forRoot([
{ path: '', redirectTo: 'login', pathMatch: 'full' },
{ path: 'login', loadChildren: () => import('./login/login.module').then(m => m.LoginModule) },
{ path: 'detail', loadChildren: () => import('./detail/detail.module').then(m => m.DetailModule) }
])
],
})
loadChildren
プロパティはコンポーネントの代わりにネイティブインポートを直接仕様してモジュールを参照する方法です。ただしこれを行うには、コンポーネントごとにモジュールを作成する必要があります。
...
import { RouterModule } from '@angular/router';
import { LoginComponent } from './login.component';
@NgModule({
imports: [
...
RouterModule.forChild([
{ path: '', component: LoginComponent },
])
],
})
一部のコードを省略して紹介しています
ここでは、RouterModule
のインポートとともに、典型的な
Angular Module
の設定がありますが、RouterModule
では forChild
によってコンポーネントを使用することを宣言しています。この設定では、ビルドを実行するときに、App Component
(Root)、 login Component
、および
detail Component
において別々のチャンクを作成します。
Live Example
If you would prefer to get hands on with the concepts and code described above, please checkout our live example of the topics above on StackBlitz.
タブの利用方法
タブを使用すると、Angular Routerにどのコンポーネントをロードする必要があるかを知るためのメカニズムをIonicが提供しますが、タブコンポーネントでは複雑な作業が行われます。簡単な例を見てみましょう。
const routes: Routes = [
{
path: 'tabs',
component: TabsPage,
children: [
{
path: 'tab1',
children: [
{
path: '',
loadChildren: () => import('../tab1/tab1.module').then(m => m.Tab1PageModule)
}
]
},
{
path: '',
redirectTo: '/tabs/tab1',
pathMatch: 'full'
}
]
},
{
path: '',
redirectTo: '/tabs/tab1',
pathMatch: 'full'
}
];
ロードする tabs
パスがあります。この例では、tabs
と設定していますが、path
の名前は変更可能です。あなたのアプリに合うように何でも設定することができます。この
routes
のオブジェクトでは、child route
も定義できます。この例では、最上位のchild route
である tab1
が
outlet
として機能し、追加の child route
を読み込むことができます。この例では、新しいコンポーネントをロードする単一の
child route
があります。タブのマークアップは次のとおりです。
<ion-tabs>
<ion-tab-bar slot="bottom">
<ion-tab-button tab="tab1">
<ion-icon name="flash"></ion-icon>
<ion-label>Tab One</ion-label>
</ion-tab-button>
</ion-tab-bar>
</ion-tabs>
Ionicを使ってアプリを作成したことがあれば、このマークアップはおなじみのはずです。ion-tabs
コンポーネントを作成し、ion-tab-bar
を提供します。ion-tab-bar
は、
tab
と一緒にion-tab-button
を提供します。最新の
@ionic/angular
はもはや
<ion-tab>
を必要とせず、開発者がタブバーを完全にカスタマイズできるようになり、すべての設定はRouterの設定によって行えるようになりました。